﻿using UnityEngine;
using System.Collections;


public class AndroidPluginInterface : MonoBehaviour
{
#if UNITY_ANDROID

	AndroidJavaObject curActivity;

	void Awake()
	{
		AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
		curActivity = jc.GetStatic<AndroidJavaObject>("currentActivity");
	}

	// Use this for initialization
	void Start()
	{
		//AndroidJNIHelper.debug = true;
		//AndroidJNI.AttachCurrentThread();
		//init();
	}

	void Destroy()
	{
		if(curActivity != null) curActivity.Dispose();
	}

	public void CallFunctionName(string msg_)
	{
		strLabelReceiveMessage = msg_;
		Debug.Log(msg_);
	}

	int init()
	{
		Debug.Log("init()");
		AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
		if(jc != null)
		{
			curActivity = jc.GetStatic<AndroidJavaObject>("currentActivity");
			jc.Dispose();
			if(curActivity != null)
			{
				Debug.Log("init success");
				return 1;
			}
		}
		Debug.Log("init failed");
		return 0;
	}

	float CallIntValue()
	{
		Debug.Log("CallIntValue()");
		if(curActivity != null)
		{
			int _left = Random.Range(1, 100);
			int _right = Random.Range(10, 90);
			float n_val = curActivity.Call<float>("GetPluginNumber", _left, _right);
			return n_val;
		}
		else
		{
			Debug.Log("CallIntValue(): androidPlugin is null");
		}
		return 0;
	}

	void requestCheckPluginMessage()
	{
		Debug.Log("requestCheckPluginMessage()");

		string[] msg_list = new string[] 
		{
			"abcde",
			"hello",
			"세번째 메시지",
			"랜덤메시지"
		};

		if(curActivity != null)
		{
			int _n = Random.Range(0, msg_list.Length - 1);
			curActivity.Call("SendMessageToUnity", "AndroidManager", "CallFunctionName", msg_list[_n]);
		}
		else
		{
			Debug.Log("requestCheckPluginMessage(): androidPlugin is null");
		}
	}

	string strLabelReturnInt = "";
	string strLabelReceiveMessage = "";

	void OnGUI()
	{
		GUILayout.BeginHorizontal();
		{
			if(GUILayout.Button("Called IntValue", GUILayout.Width(200), GUILayout.Height(100)))
			{
				float _fv = CallIntValue();
				strLabelReturnInt = _fv.ToString();
			}
			GUILayout.Label(string.Format("Return Int : {0}", strLabelReturnInt));
		}
		GUILayout.EndHorizontal();

		GUILayout.BeginHorizontal();
		{
			if(GUILayout.Button("Called Request Message", GUILayout.Width(200), GUILayout.Height(100)))
			{
				requestCheckPluginMessage();
			}
			GUILayout.Label(string.Format("RecvMsg : {0}", strLabelReceiveMessage));
		}
		GUILayout.EndHorizontal();
	}

#endif
}
